using System;
using System.ComponentModel;
using System.Reflection;

namespace DataBinding
{
	/// <summary>
	/// Summary description for AddressPropertyDescriptor.
	/// </summary>
	public class AddressPropertyDescriptor  : PropertyDescriptor
	{
		Type _type;
    PropertyInfo _pi;
    string _disName;

    public AddressPropertyDescriptor(string name, string componentType) : base(name,new Attribute[]{})
		{
		  _type=Type.GetType(componentType);
      _pi=_type.GetProperty(name);
		}
    
    public override bool CanResetValue(object component)  {
      return true;
    }

    public override Type ComponentType {
      get {return _type;}
    }

    public override object GetValue(object component) {
      return _pi.GetValue(component,null);
    }

    public override void SetValue(object component, object value) {
      _pi.SetValue(component,value,null);
    }

    public override bool IsReadOnly {
      get {return false;}
    }

    public override Type PropertyType {
      get {return _pi.PropertyType;}
    }

    public override void ResetValue(object component) {
      _pi.SetValue(component,null,null);
    }

    public override bool ShouldSerializeValue(object component)  {
      return true;
    }




	}
}
