using System;
using System.Diagnostics;
using System.Xml;
using System.ComponentModel;

namespace DataBinding {
  /// <summary>
  /// 
  /// </summary>
  public class Address : IEditableObject
  {
    
    PhoneCollection _phones;
    string _name="";
    string _add1="";
    string _add2="";
    string _city="";
    string _st="";
    string _zip="";

    AddressCollection _parent;
    bool inEdit=false;
  
    public Address()  
    { 
      
    }
    
    public string Name {
      get  {return _name;}
      set  {_name=value;}
    }
    
    public string AddressLine1  {
      get {return _add1;}
      set {_add1=value;}
    }

    public string AddressLine2  {
      get {return _add2;}
      set {_add2=value;}
    }

    public string City  {
      get { return _city; }
      set {_city=value; }
    }

    public string State {
      get {return _st;}
      set {_st=value;}
    }

    public string Zip {
      get {return _zip;}
      set {_zip=value;}
    }

    public PhoneCollection PhoneNumbers {
      get  {
        if(_phones==null)
          _phones=new PhoneCollection();

        return _phones;}
      set  {_phones=value;}
    }

    //Support for IBindingList
    internal AddressCollection Parent {
      get {return _parent;}
      set {_parent=value;}
    }
    
    private void OnAddressChanged() {
      if (!inEdit && _parent != null) {
        _parent.AddressChanged(this);
      }
    }


    //IEditable implemetation

    void IEditableObject.BeginEdit()  {
      if(!inEdit) {
        inEdit=true;
        //set backup data for restore
      }
    }

    void IEditableObject.CancelEdit() {
      if(inEdit)  {
        inEdit=false;
        //restore backup data 
      }
    }

    void IEditableObject.EndEdit()  {
      if(inEdit)  {
        inEdit=false;
        //clear backup data
      }
    }   

  }
}