using System;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Xml;

namespace DataBinding {
  
  public class PhoneCollection : CollectionBase {
    
    ArrayList _objList=new ArrayList();

    public PhoneCollection() {
      Phone tmpPhone=new Phone();
      this.Add(tmpPhone);
    }
    
    public PhoneCollection(XmlNodeList phoneNodes) {
    
      foreach(XmlNode node in phoneNodes) {
        Phone tmpPhone=new Phone();
        tmpPhone.PhoneType=node.Attributes["type"].Value;
        tmpPhone.PhoneNumber=node.InnerText;
        this.Add(tmpPhone);
      }
      
    }
    public int Add(object value)  {
      return this.List.Add((Phone)value);
    }

    public bool Contains(object value)  {
      return this.List.Contains((Phone)value);
    }

    public int IndexOf(object value)  {
      return this.List.IndexOf((Phone)value);
    }

    public void Insert(int Index, object value) {
      this.List.Insert(Index,(Phone)value);
    }

    public void Remove(object value) {
      this.List.Remove((Phone)value);
    }
  }
}
