using System;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Xml;

namespace DataBindings {
  /// <summary>
  /// Summary description for AlphaCollection.
  /// </summary>
  public class AddressCollection : System.Collections.ICollection, System.Collections.IList //, System.ComponentModel.ITypedList 
  {
    //PropertyDescriptorCollection _pdc=new PropertyDescriptorCollection(null);
    ArrayList _objList=new ArrayList();

    public AddressCollection() {

      XmlDocument doc=new XmlDocument();
      doc.Load(@"..\..\..\address.xml");
      XmlNodeList nodes=doc.SelectNodes("addressBook/addressEntry");
      foreach(XmlNode node in nodes) {
        Address tmpAddress=new Address();
        tmpAddress.Name=node.SelectSingleNode("name").InnerText;
        tmpAddress.AddressLine1=node.SelectSingleNode("address1").InnerText;
        tmpAddress.AddressLine2=node.SelectSingleNode("address2").InnerText;
        tmpAddress.City=node.SelectSingleNode("city").InnerText;
        tmpAddress.State=node.SelectSingleNode("st").InnerText;
        tmpAddress.Zip=node.SelectSingleNode("zip").InnerText;

//        XmlNodeList phoneNos=node.SelectNodes("phone");
//        tmpAddress.PhoneNumbers=new PhoneCollection(phoneNos);

        _objList.Add(tmpAddress);
      }
      
    }

//    protected PropertyDescriptorCollection PDCList {
//      get  {return _pdc;}
//      set  {_pdc=value;}
//    }

//    public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] arrDesctiptors)  { 
//      return _pdc;
//    }
    
//    public string GetListName(PropertyDescriptor[] arrDescriptors) {
//      return "";
//    }
    
    //ICollection
    virtual public int Count  {
      get {
        return _objList.Count;
      }
    }

    virtual public bool IsSynchronized  {
      get {return false;}
    }

    virtual public object SyncRoot  {
      get {return this;}
    }

    virtual public void CopyTo(Array TargetArray, int Index)  {
      throw new NotImplementedException("CopyTo not implemented");
    }


    //IList

    virtual public bool IsFixedSize {
      get {return false;}
    }

    virtual public bool IsReadOnly  {
      get {return false;}
    }
    
    public Address this[int Index] {
      get {
        if(Index<_objList.Count)
          return (Address)_objList[Index];

        return null;
      }
      set {
        if(Index<_objList.Count)
          _objList[Index]=value;
      }
    }
    
    object IList.this[int Index] {
      get {
        if(Index<_objList.Count)
          return _objList[Index];

        return null;
      }
      set {
        if(Index<_objList.Count)
          _objList[Index]=value;
      }
    }

    virtual public int Add(object Value)  {
      return _objList.Add((Address)Value);
    }

    virtual public void Clear() {
      _objList.Clear();
    }

    virtual public bool Contains(object Value)  {
      return _objList.Contains(Value);
    }

    virtual public int IndexOf(object Value)  {
      return _objList.IndexOf((Address)Value);
    }

    virtual public void Insert(int Index, object Value) {
      _objList.Insert(Index,(Address)Value);
    }

    virtual public void Remove(object Value) {
      _objList.Remove((Address)Value);
    }

    virtual public void RemoveAt(int Index) {
      _objList.RemoveAt(Index);
    }


    virtual public IEnumerator GetEnumerator() {
      return new AddressCollectionEnumerator(this);
    }
    
    /// <summary>
    /// RelatedPoliciesEnumerator
    /// </summary>
    class AddressCollectionEnumerator : IEnumerator  {

      int _index=-1;
      AddressCollection _collection;

      internal AddressCollectionEnumerator(AddressCollection collectionClass)  {
        _collection=collectionClass;

        if(_collection._objList.Count==0)
          _index=-1;
      }

      public bool MoveNext()  {

        if(_index<_collection._objList.Count-1) {
          _index++;
          return true;
        }
        return false;

      }

      public void Reset() {
        _index=-1;
      }

      public Object Current {
        get {
          if(_index>=0)
            return _collection._objList[_index];
          else
            throw new InvalidOperationException("Can't do that");
        }
      }

    }
  }
}
