using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataBindings
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    private System.Windows.Forms.TextBox txtAddress1;
    private System.Windows.Forms.TextBox txtAddress2;
    private System.Windows.Forms.TextBox txtCity;
    private System.Windows.Forms.TextBox txtState;
    private System.Windows.Forms.TextBox txtZip;
    private System.Windows.Forms.TextBox txtName;
    private System.Windows.Forms.Button btnPrev;
    private System.Windows.Forms.Button btnNext;

    private AddressCollection addresses=new AddressCollection();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
      txtName.DataBindings.Add("Text",addresses,"Name");
      txtAddress1.DataBindings.Add("Text",addresses,"AddressLine1");
      txtAddress2.DataBindings.Add("Text",addresses,"AddressLine2");
      txtCity.DataBindings.Add("Text",addresses,"City");
      txtState.DataBindings.Add("Text",addresses,"State");
      txtZip.DataBindings.Add("Text",addresses,"Zip");
      txtAddress1.DataBindings["Text"].Format+=new ConvertEventHandler(this.FormatEventHandler);
      txtAddress1.DataBindings["Text"].Parse+=new ConvertEventHandler(this.ParseEventHandler);
      this.BindingContext[addresses].PositionChanged+=new EventHandler(this.PositionChangeEventHandler);
      this.BindingContext[addresses].CurrentChanged+=new EventHandler(this.CurrentChangeEventHandler);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.txtAddress1 = new System.Windows.Forms.TextBox();
      this.txtAddress2 = new System.Windows.Forms.TextBox();
      this.txtCity = new System.Windows.Forms.TextBox();
      this.txtState = new System.Windows.Forms.TextBox();
      this.txtZip = new System.Windows.Forms.TextBox();
      this.txtName = new System.Windows.Forms.TextBox();
      this.btnPrev = new System.Windows.Forms.Button();
      this.btnNext = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // txtAddress1
      // 
      this.txtAddress1.Location = new System.Drawing.Point(96, 32);
      this.txtAddress1.Name = "txtAddress1";
      this.txtAddress1.Size = new System.Drawing.Size(208, 20);
      this.txtAddress1.TabIndex = 0;
      this.txtAddress1.Text = "";
      // 
      // txtAddress2
      // 
      this.txtAddress2.Location = new System.Drawing.Point(96, 56);
      this.txtAddress2.Name = "txtAddress2";
      this.txtAddress2.Size = new System.Drawing.Size(208, 20);
      this.txtAddress2.TabIndex = 1;
      this.txtAddress2.Text = "";
      // 
      // txtCity
      // 
      this.txtCity.Location = new System.Drawing.Point(96, 80);
      this.txtCity.Name = "txtCity";
      this.txtCity.Size = new System.Drawing.Size(96, 20);
      this.txtCity.TabIndex = 2;
      this.txtCity.Text = "";
      // 
      // txtState
      // 
      this.txtState.Location = new System.Drawing.Point(200, 80);
      this.txtState.Name = "txtState";
      this.txtState.Size = new System.Drawing.Size(32, 20);
      this.txtState.TabIndex = 4;
      this.txtState.Text = "";
      // 
      // txtZip
      // 
      this.txtZip.Location = new System.Drawing.Point(240, 80);
      this.txtZip.Name = "txtZip";
      this.txtZip.Size = new System.Drawing.Size(64, 20);
      this.txtZip.TabIndex = 5;
      this.txtZip.Text = "";
      // 
      // txtName
      // 
      this.txtName.Location = new System.Drawing.Point(96, 8);
      this.txtName.Name = "txtName";
      this.txtName.Size = new System.Drawing.Size(208, 20);
      this.txtName.TabIndex = 6;
      this.txtName.Text = "";
      // 
      // btnPrev
      // 
      this.btnPrev.Location = new System.Drawing.Point(72, 112);
      this.btnPrev.Name = "btnPrev";
      this.btnPrev.TabIndex = 7;
      this.btnPrev.Text = "Previous";
      this.btnPrev.Click += new System.EventHandler(this.btnPrev_Click);
      // 
      // btnNext
      // 
      this.btnNext.Location = new System.Drawing.Point(176, 112);
      this.btnNext.Name = "btnNext";
      this.btnNext.TabIndex = 8;
      this.btnNext.Text = "Next";
      this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(320, 150);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.btnNext,
                                                                  this.btnPrev,
                                                                  this.txtName,
                                                                  this.txtZip,
                                                                  this.txtState,
                                                                  this.txtCity,
                                                                  this.txtAddress2,
                                                                  this.txtAddress1});
      this.Name = "Form1";
      this.Text = "Form1";
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void btnPrev_Click(object sender, System.EventArgs e) {
      this.BindingContext[addresses].Position-=1;
    }

    private void btnNext_Click(object sender, System.EventArgs e) {
      this.BindingContext[addresses].Position+=1;
    }

    private void FormatEventHandler(object sender, ConvertEventArgs ev) {
      System.Diagnostics.Trace.WriteLine("FormatEventHandler" + ev.Value.ToString());
    }
    private void ParseEventHandler(object sender, ConvertEventArgs ev) {
      System.Diagnostics.Trace.WriteLine("ParseEventHandler" + ev.Value.ToString());
    }
    private void PositionChangeEventHandler(object sender, EventArgs ev) {
      System.Diagnostics.Trace.WriteLine("PositionEventHandler");
    }
    private void CurrentChangeEventHandler(object sender, EventArgs ev) {
      System.Diagnostics.Trace.WriteLine("CurrentChangeEventHandler");
    }
	}
}
