using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataBinding
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
    private System.Windows.Forms.TextBox txtName;
    private System.Windows.Forms.TextBox txtAddress1;
    private System.Windows.Forms.TextBox txtAddress2;
    private System.Windows.Forms.TextBox txtCity;
    private System.Windows.Forms.TextBox txtState;
    private System.Windows.Forms.TextBox txtZip;
    private System.Windows.Forms.DataGrid gridPhones;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.Label label2;
    private System.Windows.Forms.Label label3;
    private System.Windows.Forms.Label label4;
    private System.Windows.Forms.Button btnPrev;
    private System.Windows.Forms.Button btnNext;

    AddressCollection _dataSource;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

      _dataSource=new AddressCollection();
      txtName.DataBindings.Add("Text",_dataSource,"Name");
      txtAddress1.DataBindings.Add("Text",_dataSource,"AddressLine1");
      txtAddress2.DataBindings.Add("Text",_dataSource,"AddressLine2");
      txtCity.DataBindings.Add("Text",_dataSource,"City");
      txtState.DataBindings.Add("Text",_dataSource,"State");
      Binding zipBinding=new Binding("Text",_dataSource,"Zip");
      zipBinding.Format+=new ConvertEventHandler(AddPlusFour);
      zipBinding.Parse+=new ConvertEventHandler(RemovePlusFour);
      txtZip.DataBindings.Add(zipBinding);
      gridPhones.DataBindings.Add("DataSource",_dataSource,"PhoneNumbers");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.txtName = new System.Windows.Forms.TextBox();
      this.txtAddress1 = new System.Windows.Forms.TextBox();
      this.txtAddress2 = new System.Windows.Forms.TextBox();
      this.txtCity = new System.Windows.Forms.TextBox();
      this.txtState = new System.Windows.Forms.TextBox();
      this.txtZip = new System.Windows.Forms.TextBox();
      this.gridPhones = new System.Windows.Forms.DataGrid();
      this.label1 = new System.Windows.Forms.Label();
      this.label2 = new System.Windows.Forms.Label();
      this.label3 = new System.Windows.Forms.Label();
      this.label4 = new System.Windows.Forms.Label();
      this.btnPrev = new System.Windows.Forms.Button();
      this.btnNext = new System.Windows.Forms.Button();
      ((System.ComponentModel.ISupportInitialize)(this.gridPhones)).BeginInit();
      this.SuspendLayout();
      // 
      // txtName
      // 
      this.txtName.Location = new System.Drawing.Point(112, 32);
      this.txtName.Name = "txtName";
      this.txtName.Size = new System.Drawing.Size(232, 20);
      this.txtName.TabIndex = 0;
      this.txtName.Text = "";
      // 
      // txtAddress1
      // 
      this.txtAddress1.Location = new System.Drawing.Point(112, 56);
      this.txtAddress1.Name = "txtAddress1";
      this.txtAddress1.Size = new System.Drawing.Size(232, 20);
      this.txtAddress1.TabIndex = 1;
      this.txtAddress1.Text = "";
      // 
      // txtAddress2
      // 
      this.txtAddress2.Location = new System.Drawing.Point(112, 80);
      this.txtAddress2.Name = "txtAddress2";
      this.txtAddress2.Size = new System.Drawing.Size(232, 20);
      this.txtAddress2.TabIndex = 2;
      this.txtAddress2.Text = "";
      // 
      // txtCity
      // 
      this.txtCity.Location = new System.Drawing.Point(112, 104);
      this.txtCity.Name = "txtCity";
      this.txtCity.Size = new System.Drawing.Size(120, 20);
      this.txtCity.TabIndex = 3;
      this.txtCity.Text = "";
      // 
      // txtState
      // 
      this.txtState.Location = new System.Drawing.Point(240, 104);
      this.txtState.Name = "txtState";
      this.txtState.Size = new System.Drawing.Size(32, 20);
      this.txtState.TabIndex = 4;
      this.txtState.Text = "";
      // 
      // txtZip
      // 
      this.txtZip.Location = new System.Drawing.Point(280, 104);
      this.txtZip.Name = "txtZip";
      this.txtZip.Size = new System.Drawing.Size(64, 20);
      this.txtZip.TabIndex = 5;
      this.txtZip.Text = "";
      // 
      // gridPhones
      // 
      this.gridPhones.DataMember = "";
      this.gridPhones.HeaderForeColor = System.Drawing.SystemColors.ControlText;
      this.gridPhones.Location = new System.Drawing.Point(112, 136);
      this.gridPhones.Name = "gridPhones";
      this.gridPhones.Size = new System.Drawing.Size(192, 80);
      this.gridPhones.TabIndex = 6;
      // 
      // label1
      // 
      this.label1.Location = new System.Drawing.Point(8, 32);
      this.label1.Name = "label1";
      this.label1.TabIndex = 7;
      this.label1.Text = "Name";
      this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
      // 
      // label2
      // 
      this.label2.Location = new System.Drawing.Point(8, 56);
      this.label2.Name = "label2";
      this.label2.TabIndex = 8;
      this.label2.Text = "Address";
      this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
      // 
      // label3
      // 
      this.label3.Location = new System.Drawing.Point(8, 104);
      this.label3.Name = "label3";
      this.label3.TabIndex = 9;
      this.label3.Text = "City, State && Zip";
      this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
      // 
      // label4
      // 
      this.label4.Location = new System.Drawing.Point(8, 136);
      this.label4.Name = "label4";
      this.label4.TabIndex = 10;
      this.label4.Text = "Phone List";
      this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
      // 
      // btnPrev
      // 
      this.btnPrev.Location = new System.Drawing.Point(72, 240);
      this.btnPrev.Name = "btnPrev";
      this.btnPrev.TabIndex = 11;
      this.btnPrev.Text = "Previous";
      this.btnPrev.Click += new System.EventHandler(this.btnPrev_Click);
      // 
      // btnNext
      // 
      this.btnNext.Location = new System.Drawing.Point(184, 240);
      this.btnNext.Name = "btnNext";
      this.btnNext.TabIndex = 12;
      this.btnNext.Text = "Next";
      this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(352, 286);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.btnNext,
                                                                  this.btnPrev,
                                                                  this.label4,
                                                                  this.label3,
                                                                  this.label2,
                                                                  this.label1,
                                                                  this.gridPhones,
                                                                  this.txtZip,
                                                                  this.txtState,
                                                                  this.txtCity,
                                                                  this.txtAddress2,
                                                                  this.txtAddress1,
                                                                  this.txtName});
      this.Name = "Form1";
      this.Text = "Form1";
      ((System.ComponentModel.ISupportInitialize)(this.gridPhones)).EndInit();
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void btnNext_Click(object sender, System.EventArgs e) {
      this.BindingContext[_dataSource].Position+=1;
    }

    private void btnPrev_Click(object sender, System.EventArgs e) {
      this.BindingContext[_dataSource].Position-=1;
    }

    private void AddPlusFour(object sender, ConvertEventArgs ev) {
      string zip=ev.Value.ToString();
      if(zip.Length==5)
        ev.Value=zip + "-0000";
    }

    private void RemovePlusFour(object sender, ConvertEventArgs ev) {
      string zip=ev.Value.ToString();
      if(zip.Length>5)
        ev.Value=zip.Substring(0,5);
    }
	}
}
