using System;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Xml;

namespace DataBinding {
  
  public class AddressCollection : CollectionBase, ITypedList
  {
    PropertyDescriptorCollection _pdc=new PropertyDescriptorCollection(null);
    
    public AddressCollection() {
    
      XmlDocument doc=new XmlDocument();
      doc.Load(@"..\..\..\address.xml");
      XmlNodeList nodes=doc.SelectNodes("addressBook/addressEntry");
      foreach(XmlNode node in nodes)  {
        Address tmpAdd=new Address();
        tmpAdd.Name=node.SelectSingleNode("name").InnerText;
        tmpAdd.AddressLine1=node.SelectSingleNode("address1").InnerText;
        tmpAdd.AddressLine2=node.SelectSingleNode("address2").InnerText;
        tmpAdd.City=node.SelectSingleNode("city").InnerText;
        tmpAdd.State=node.SelectSingleNode("st").InnerText;
        tmpAdd.Zip=node.SelectSingleNode("zip").InnerText;
        tmpAdd.PhoneNumbers=new PhoneCollection(node.SelectNodes("phone"));
        this.List.Add(tmpAdd);
      }
      
      _pdc.Add(new AddressPropertyDescriptor("Name", "DataBinding.Address"));
      _pdc.Add(new AddressPropertyDescriptor("City", "DataBinding.Address"));
      _pdc.Add(new AddressPropertyDescriptor("PhoneNumbers", "DataBinding.Address"));

    }

    public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] arrDesctiptors)  { 
      return _pdc;
    }

    public string GetListName(PropertyDescriptor[] arrDescriptors) {
      return "List";
    }

    public int Add(object value)  {
      return this.List.Add((Address)value);
    }

    public bool Contains(object value)  {
      return this.List.Contains((Address)value);
    }

    public int IndexOf(object value)  {
      return this.List.IndexOf((Address)value);
    }

    public void Insert(int Index, object value) {
      this.List.Insert(Index,(Address)value);
    }

    public void Remove(object value) {
      this.List.Remove((Address)value);
    }

  }
}
