using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Data.SqlClient;
using System.Drawing.Printing;

namespace GridPrinting
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		//Stored Page Settings object
		private PageSettings oPageSettings;

		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.MainMenu mnuMain;
		private System.Windows.Forms.PrintPreviewDialog ppDialog;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.PrintDialog oPrintDialog;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.PageSetupDialog oPageSetup;
		private System.Windows.Forms.DataGrid dGrid;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			oPageSettings = new PageSettings();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.dGrid = new System.Windows.Forms.DataGrid();
			this.mnuMain = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.ppDialog = new System.Windows.Forms.PrintPreviewDialog();
			this.oPrintDialog = new System.Windows.Forms.PrintDialog();
			this.oPageSetup = new System.Windows.Forms.PageSetupDialog();
			((System.ComponentModel.ISupportInitialize)(this.dGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// dGrid
			// 
			this.dGrid.DataMember = "";
			this.dGrid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dGrid.Name = "dGrid";
			this.dGrid.Size = new System.Drawing.Size(292, 266);
			this.dGrid.TabIndex = 0;
			// 
			// mnuMain
			// 
			this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem3,
																					  this.menuItem4,
																					  this.menuItem2,
																					  this.menuItem5,
																					  this.menuItem6});
			this.menuItem1.Text = "&File";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 0;
			this.menuItem3.Text = "Page Setup...";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 1;
			this.menuItem4.Text = "Print...";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.Text = "Print Preview...";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "-";
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 4;
			this.menuItem6.Text = "Exit";
			// 
			// ppDialog
			// 
			this.ppDialog.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.ppDialog.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.ppDialog.ClientSize = new System.Drawing.Size(400, 300);
			this.ppDialog.Enabled = true;
			this.ppDialog.Icon = ((System.Drawing.Icon)(resources.GetObject("ppDialog.Icon")));
			this.ppDialog.Location = new System.Drawing.Point(121, 21);
			this.ppDialog.MaximumSize = new System.Drawing.Size(0, 0);
			this.ppDialog.Name = "ppDialog";
			this.ppDialog.Opacity = 1;
			this.ppDialog.TransparencyKey = System.Drawing.Color.Empty;
			this.ppDialog.Visible = false;
			// 
			// oPrintDialog
			// 
			this.oPrintDialog.AllowSomePages = true;
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dGrid});
			this.Menu = this.mnuMain;
			this.Name = "frmMain";
			this.Text = "Printing Grid Example";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			try
			{
				//COnnection to database - get dataset
				SqlConnection aConn = new SqlConnection("data source=HOBBIT;initial catalog=Northwind;integrated security=SSPI;");
				SqlDataAdapter sqlAdapter = new SqlDataAdapter("Select CompanyName, Address, City, Region, PostalCode, Country from Customers",aConn);
				DataSet aDataSet = new DataSet();
				sqlAdapter.Fill(aDataSet);

				//Assign dataset to Grid
				dGrid.DataSource = aDataSet;
				dGrid.SetDataBinding(aDataSet.Tables[0],"");	
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString(),"Error");
			}
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			//Setup the document to print
			PrintGridDocument aDoc = new PrintGridDocument(dGrid);
			aDoc.Title = "Employee Report";
			oPrintDialog.Document = aDoc;
			if (oPrintDialog.ShowDialog() == DialogResult.OK)
			{
				//Display the print preview dialog
				aDoc.DefaultPageSettings = oPageSettings;
				ppDialog.Document = aDoc;
				ppDialog.ShowDialog();
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			oPageSetup.PageSettings = oPageSettings;
			if(oPageSetup.ShowDialog() == DialogResult.OK)
			{
				oPageSettings = oPageSetup.PageSettings;
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			//Setup the document to print
			PrintGridDocument aDoc = new PrintGridDocument(dGrid);
			aDoc.Title = "Employee Report";
			oPrintDialog.Document = aDoc;
			if (oPrintDialog.ShowDialog() == DialogResult.OK)
			{
				//Display the print preview dialog
				aDoc.DefaultPageSettings = oPageSettings;
				try
				{
					//Print the document
					aDoc.Print();
				}
				catch(Exception ex)
				{
					//Display any errors
					MessageBox.Show(ex.ToString());
				}
			}
		}
	}
}
