using System;
using System.Drawing;
using System.Drawing.Printing;

namespace TestPrinters
{
	/// <summary>
	/// Summary description for PrinterSettingsDisplay.
	/// </summary>
	public class PrinterSettingsDisplay
	{
		public PrinterSettingsDisplay()
		{
		}

		public void DisplayPrinterCaps(Graphics oGraphics)
		{
			PrinterSettings pSettings = new PrinterSettings();
			Font printFont = new Font("Arial", 10);
			int x=1;
			int nHeight = (int)printFont.GetHeight(oGraphics);

			foreach(string sPtr in PrinterSettings.InstalledPrinters)
			{
				pSettings.PrinterName = sPtr;
				if(pSettings.IsValid)
				{
					oGraphics.DrawString(sPtr, printFont,Brushes.Black,5,x + 5);
					oGraphics.DrawString("Can Duplex: " + pSettings.CanDuplex.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight));
					oGraphics.DrawString("Is Default: " + pSettings.IsDefaultPrinter.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*2));
					oGraphics.DrawString("Is Plotter: " + pSettings.IsPlotter.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*3));
					oGraphics.DrawString("Landscape Angle: " + pSettings.LandscapeAngle.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*4));
					oGraphics.DrawString("Maximum Copies: " + pSettings.MaximumCopies.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*5));
					oGraphics.DrawString("Maximum Page: " + pSettings.MaximumPage.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*6));
					oGraphics.DrawString("Minimum Page: " + pSettings.MinimumPage.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*7));
					oGraphics.DrawString("Supports Color: " + pSettings.SupportsColor.ToString(), 
						printFont,Brushes.Black,15,x + (5 + nHeight*8));
					x = x + ((5 + nHeight*8) + nHeight);
					//return;
				}

			}

			return;
		}
	}
}
