using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Wrox.Samples.AddressControl
{
	/// <summary>
	/// Summary description for ExtTextFieldEditorForm.
	/// </summary>
	public class AddressLabelAlignmentEditorForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    private System.Windows.Forms.Button btnOK;
    private System.Windows.Forms.Button btnCancel;
    private System.Windows.Forms.RadioButton rdoLeft;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.Label lblLeft;
    private System.Windows.Forms.Label lblTop;
    private System.Windows.Forms.RadioButton rdoTop;

		public AddressLabelAlignmentEditorForm(AddressLabelAlignment OriginalValue)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
      
      this.btnOK.Click += new System.EventHandler(AcceptChanges);
      this.btnCancel.Click += new System.EventHandler(CancelChanges);
      this.rdoTop.Tag = AddressLabelAlignment.Top;
      this.rdoLeft.Tag = AddressLabelAlignment.Left;

      switch (OriginalValue)
      {
        case AddressLabelAlignment.Left:
          this.rdoLeft.Checked = true;
          break;
        case AddressLabelAlignment.Top:
          this.rdoTop.Checked = true;
          break;
      }

      this.rdoLeft.CheckedChanged += new System.EventHandler(RadioButtonChange);
      this.rdoTop.CheckedChanged += new System.EventHandler(RadioButtonChange);
 
      this.Text = "Selecting Label Alignment";
		}

    public AddressLabelAlignment SelectedAlignment
    {
      get
      {
        if (rdoLeft.Checked)
        {
          return (AddressLabelAlignment)(rdoLeft.Tag);
        }
        else
        {
          return (AddressLabelAlignment)(rdoTop.Tag);
        }
      }
    }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.btnOK = new System.Windows.Forms.Button();
      this.btnCancel = new System.Windows.Forms.Button();
      this.rdoLeft = new System.Windows.Forms.RadioButton();
      this.rdoTop = new System.Windows.Forms.RadioButton();
      this.label1 = new System.Windows.Forms.Label();
      this.lblLeft = new System.Windows.Forms.Label();
      this.lblTop = new System.Windows.Forms.Label();
      this.SuspendLayout();
      // 
      // btnOK
      // 
      this.btnOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
      this.btnOK.Location = new System.Drawing.Point(44, 112);
      this.btnOK.Name = "btnOK";
      this.btnOK.TabIndex = 1;
      this.btnOK.Text = "OK";
      // 
      // btnCancel
      // 
      this.btnCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
      this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
      this.btnCancel.Location = new System.Drawing.Point(136, 112);
      this.btnCancel.Name = "btnCancel";
      this.btnCancel.TabIndex = 2;
      this.btnCancel.Text = "Cancel";
      // 
      // rdoLeft
      // 
      this.rdoLeft.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.rdoLeft.Location = new System.Drawing.Point(187, 4);
      this.rdoLeft.Name = "rdoLeft";
      this.rdoLeft.Size = new System.Drawing.Size(60, 24);
      this.rdoLeft.TabIndex = 3;
      this.rdoLeft.Text = "Left";
      // 
      // rdoTop
      // 
      this.rdoTop.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.rdoTop.Location = new System.Drawing.Point(187, 28);
      this.rdoTop.Name = "rdoTop";
      this.rdoTop.Size = new System.Drawing.Size(60, 24);
      this.rdoTop.TabIndex = 4;
      this.rdoTop.Text = "Top";
      // 
      // label1
      // 
      this.label1.BackColor = System.Drawing.SystemColors.Window;
      this.label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
      this.label1.ForeColor = System.Drawing.SystemColors.WindowText;
      this.label1.Location = new System.Drawing.Point(60, 28);
      this.label1.Name = "label1";
      this.label1.TabIndex = 5;
      this.label1.Text = "Sample Text";
      this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
      // 
      // lblLeft
      // 
      this.lblLeft.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.lblLeft.Location = new System.Drawing.Point(4, 28);
      this.lblLeft.Name = "lblLeft";
      this.lblLeft.Size = new System.Drawing.Size(52, 23);
      this.lblLeft.TabIndex = 6;
      this.lblLeft.Text = "Label";
      this.lblLeft.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
      // 
      // lblTop
      // 
      this.lblTop.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.lblTop.Location = new System.Drawing.Point(60, 4);
      this.lblTop.Name = "lblTop";
      this.lblTop.Size = new System.Drawing.Size(52, 23);
      this.lblTop.TabIndex = 7;
      this.lblTop.Text = "Label";
      this.lblTop.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
      // 
      // AddressLabelAlignmentEditorForm
      // 
      this.AcceptButton = this.btnOK;
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.CancelButton = this.btnCancel;
      this.ClientSize = new System.Drawing.Size(250, 147);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.lblTop,
                                                                  this.lblLeft,
                                                                  this.label1,
                                                                  this.rdoTop,
                                                                  this.rdoLeft,
                                                                  this.btnCancel,
                                                                  this.btnOK});
      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
      this.Name = "AddressLabelAlignmentEditorForm";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "ExtTextFieldEditorForm";
      this.ResumeLayout(false);

    }
		#endregion

    private void AcceptChanges(object sender, System.EventArgs e)
    {
      DialogResult = DialogResult.OK;
    }
    private void CancelChanges(object sender, System.EventArgs e)
    {
      DialogResult = DialogResult.Cancel;
    }

    private void RadioButtonChange(object sender, System.EventArgs e)
    {
      if (((RadioButton)sender).Checked)
      {
        switch ((AddressLabelAlignment)((RadioButton)sender).Tag)
        {
          case AddressLabelAlignment.Left:
            this.lblLeft.Visible = true;
            this.lblTop.Visible = false;
            break;
          case AddressLabelAlignment.Top:
            this.lblTop.Visible = true;
            this.lblLeft.Visible = false;
            break;
        }           
      }
    }
	}
}
