using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using Wrox.Samples;

namespace Wrox.Samples.AddressControl
{
	/// <summary>
	/// Public accessor class to reference objects of type Wrox.Samples.ExtTextBox.
	/// </summary>
	public class ExtTextField
	{
		private ExtTextBox mControl;
    
    
    /// <summary>
    /// Initializes a new instance of the Wrox.Samples.AddressControl.ExtTextField class
    /// </summary>    
    public ExtTextField(ExtTextBox TextBoxControl)
		{
      mControl = TextBoxControl;
		}

    /// <summary>
    /// Gets or sets the current text in the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </summary>
    public string Text
    {
      get {return mControl.Text;}
      set {mControl.Text = value;}
    }

    /// <summary>
    /// Gets or sets the foreground color of the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </summary>
    public Color ForeColor
    {
      get {return mControl.ForeColor;}
      set {mControl.ForeColor = value;}
    }
    
    /// <summary>
    /// Gets or sets the background color of the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </summary>
    public Color BackColor
    {
      get {return mControl.BackColor;}
      set {mControl.BackColor = value;}
    }
    
    /// <summary>
    /// Gets or sets the IsRequired value of the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </summary>
    public bool IsRequired
    {
      get {return mControl.IsRequired;}
      set {mControl.IsRequired = value;}
    }


    /// <summary>
    /// Appends text to the current text of the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </summary>
    /// <param name="text"> The text to append to the current contents of the Wrox.Samples.ExtTextBox.</param>
    public void AppendText(string text)
    {
      mControl.AppendText(text);
    }

    /// <summary>
    /// Gets the data bindings for the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </summary>
    /// <returns>
    /// A System.Windows.Forms.ControlBindingsCollection from the Wrox.Samples.ExtTextBox control referenced by this Wrox.Samples.AddressControl.ExtTextField object.
    /// </returns>
    public ControlBindingsCollection DataBindings
    {
      get{return mControl.DataBindings;}     
    }


	}
}
