using System;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Drawing.Design;
using System.ComponentModel;

namespace Wrox.Samples.AddressControl
{
	/// <summary>
	/// Summary description for ExtTextBoxEditor.
	/// </summary>
	public class ExtTextFieldEditor : System.Drawing.Design.UITypeEditor
	{
		public ExtTextFieldEditor()
		{
			
		}

    public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
    {
      return UITypeEditorEditStyle.Modal;
    }

    public override object EditValue(ITypeDescriptorContext context, IServiceProvider sp, object value)
    {
      ExtTextField OriginalValue = (ExtTextField) value;
      
      ExtTextFieldEditorForm frm = new ExtTextFieldEditorForm(OriginalValue);
      IWindowsFormsEditorService EdSvc = (IWindowsFormsEditorService) sp.GetService(typeof(IWindowsFormsEditorService));

      if (DialogResult.OK ==  EdSvc.ShowDialog(frm))
      {
       OriginalValue.ForeColor = frm.EditedField.ForeColor;
       OriginalValue.BackColor = frm.EditedField.BackColor;
       OriginalValue.Text = frm.EditedField.Text;
       OriginalValue.IsRequired = frm.EditedField.IsRequired;
      };
     
      return OriginalValue;
    }
	}
}
