using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Wrox.Samples.AddressControl
{
	/// <summary>
	/// Summary description for ExtTextFieldEditorForm.
	/// </summary>
	public class ExtTextFieldEditorForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    private System.Windows.Forms.PropertyGrid grdProperties;
    private System.Windows.Forms.Button btnOK;
    private System.Windows.Forms.Button btnCancel;

    private ExtTextField mEditedField;

		public ExtTextFieldEditorForm(ExtTextField OriginalField)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
      this.btnOK.Click += new System.EventHandler(AcceptChanges);
      this.btnCancel.Click += new System.EventHandler(CancelChanges);

      mEditedField = new ExtTextField();

      mEditedField.ForeColor = OriginalField.ForeColor;
      mEditedField.BackColor = OriginalField.BackColor;
      mEditedField.Text = OriginalField.Text;
      mEditedField.IsRequired = OriginalField.IsRequired;

      grdProperties.SelectedObject = mEditedField;      
      this.Text = "Editing ExtTextField Properties";
		}

    public ExtTextField EditedField
    {
      get{return mEditedField;}
    }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.grdProperties = new System.Windows.Forms.PropertyGrid();
      this.btnOK = new System.Windows.Forms.Button();
      this.btnCancel = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // grdProperties
      // 
      this.grdProperties.CommandsVisibleIfAvailable = true;
      this.grdProperties.Dock = System.Windows.Forms.DockStyle.Top;
      this.grdProperties.LargeButtons = false;
      this.grdProperties.LineColor = System.Drawing.SystemColors.ScrollBar;
      this.grdProperties.Name = "grdProperties";
      this.grdProperties.Size = new System.Drawing.Size(280, 248);
      this.grdProperties.TabIndex = 0;
      this.grdProperties.Text = "propertyGrid1";
      this.grdProperties.ViewBackColor = System.Drawing.SystemColors.Window;
      this.grdProperties.ViewForeColor = System.Drawing.SystemColors.WindowText;
      // 
      // btnOK
      // 
      this.btnOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
      this.btnOK.Location = new System.Drawing.Point(58, 256);
      this.btnOK.Name = "btnOK";
      this.btnOK.TabIndex = 1;
      this.btnOK.Text = "OK";
      // 
      // btnCancel
      // 
      this.btnCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
      this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
      this.btnCancel.Location = new System.Drawing.Point(147, 256);
      this.btnCancel.Name = "btnCancel";
      this.btnCancel.TabIndex = 2;
      this.btnCancel.Text = "Cancel";
      // 
      // ExtTextFieldEditorForm
      // 
      this.AcceptButton = this.btnOK;
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.CancelButton = this.btnCancel;
      this.ClientSize = new System.Drawing.Size(280, 285);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.btnCancel,
                                                                  this.btnOK,
                                                                  this.grdProperties});
      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
      this.Name = "ExtTextFieldEditorForm";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "ExtTextFieldEditorForm";
      this.ResumeLayout(false);

    }
		#endregion

    private void AcceptChanges(object sender, System.EventArgs e)
    {
      DialogResult = DialogResult.OK;
    }
    private void CancelChanges(object sender, System.EventArgs e)
    {
      DialogResult = DialogResult.Cancel;
    }
	}
}
