using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Wrox.Samples.GUI;

namespace ExtendedControlTest
{
	/// <summary>Extended TextBox Test Consumer Form</summary>
	public class frmMain : System.Windows.Forms.Form
	{
    private System.Windows.Forms.CheckBox chkEnabled;
    private System.Windows.Forms.CheckBox chkReadOnly;
    private System.Windows.Forms.CheckBox chkIsRequired;
    private System.Windows.Forms.Button btnBackColor;
    private System.Windows.Forms.ColorDialog myColorDialog;
    private Wrox.Samples.GUI.ExtTextBox myExtendedTextBox;
    
    /// <summary>Required designer variable.</summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			// Required for Windows Form Designer support
			InitializeComponent();

      this.chkEnabled.CheckedChanged += new System.EventHandler(ToggleEnabled);
      this.chkReadOnly.CheckedChanged += new System.EventHandler(ToggleReadOnly);
      this.chkIsRequired.CheckedChanged += new System.EventHandler(ToggleIsRequired);
      this.btnBackColor.Click += new System.EventHandler(ChangeBackColor);
      this.myExtendedTextBox.IsRequiredChanged += new System.EventHandler(NotifyRequiredChange);
      this.chkEnabled.Checked = myExtendedTextBox.Enabled;
      this.chkReadOnly.Checked = myExtendedTextBox.ReadOnly;
      this.chkIsRequired.Checked = myExtendedTextBox.IsRequired;
		}

		/// <summary>Clean up any resources being used.</summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.chkReadOnly = new System.Windows.Forms.CheckBox();
      this.btnBackColor = new System.Windows.Forms.Button();
      this.chkEnabled = new System.Windows.Forms.CheckBox();
      this.chkIsRequired = new System.Windows.Forms.CheckBox();
      this.myColorDialog = new System.Windows.Forms.ColorDialog();
      this.myExtendedTextBox = new Wrox.Samples.GUI.ExtTextBox();
      this.SuspendLayout();
      // 
      // chkReadOnly
      // 
      this.chkReadOnly.Location = new System.Drawing.Point(36, 88);
      this.chkReadOnly.Name = "chkReadOnly";
      this.chkReadOnly.Size = new System.Drawing.Size(80, 16);
      this.chkReadOnly.TabIndex = 3;
      this.chkReadOnly.Text = "Read Only";
      // 
      // btnBackColor
      // 
      this.btnBackColor.BackColor = System.Drawing.SystemColors.Control;
      this.btnBackColor.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.btnBackColor.ForeColor = System.Drawing.SystemColors.ControlText;
      this.btnBackColor.Location = new System.Drawing.Point(132, 80);
      this.btnBackColor.Name = "btnBackColor";
      this.btnBackColor.Size = new System.Drawing.Size(78, 32);
      this.btnBackColor.TabIndex = 5;
      this.btnBackColor.Text = "BackColor";
      // 
      // chkEnabled
      // 
      this.chkEnabled.Location = new System.Drawing.Point(36, 48);
      this.chkEnabled.Name = "chkEnabled";
      this.chkEnabled.Size = new System.Drawing.Size(80, 16);
      this.chkEnabled.TabIndex = 1;
      this.chkEnabled.Text = "Enabled";
      // 
      // chkIsRequired
      // 
      this.chkIsRequired.Location = new System.Drawing.Point(132, 48);
      this.chkIsRequired.Name = "chkIsRequired";
      this.chkIsRequired.Size = new System.Drawing.Size(88, 16);
      this.chkIsRequired.TabIndex = 2;
      this.chkIsRequired.Text = "Is Required";
      // 
      // myExtendedTextBox
      // 
      this.myExtendedTextBox.BackColor = System.Drawing.SystemColors.Window;
      this.myExtendedTextBox.Location = new System.Drawing.Point(16, 8);
      this.myExtendedTextBox.Name = "myExtendedTextBox";
      this.myExtendedTextBox.ReadOnly = false;
      this.myExtendedTextBox.Size = new System.Drawing.Size(224, 20);
      this.myExtendedTextBox.TabIndex = 6;
      this.myExtendedTextBox.Text = "myExtendedTextBox";
      // 
      // frmMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(256, 125);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.myExtendedTextBox,
                                                                  this.chkIsRequired,
                                                                  this.chkEnabled,
                                                                  this.btnBackColor,
                                                                  this.chkReadOnly});
      this.Name = "frmMain";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "Extended TextBox Consumer";
      this.ResumeLayout(false);

    }
		#endregion

    private void ToggleEnabled(object sender, System.EventArgs e)
    {
      myExtendedTextBox.Enabled = ((CheckBox)sender).Checked;
    }

    private void ToggleReadOnly(object sender, System.EventArgs e)
    {
      myExtendedTextBox.ReadOnly = ((CheckBox)sender).Checked;
    }

    private void ChangeBackColor(object sender, System.EventArgs e)
    {
      ColorDialog myColorDialog = new ColorDialog();
      myColorDialog.AllowFullOpen = false;
      myColorDialog.Color = myExtendedTextBox.BackColor;
      myColorDialog.ShowDialog();
      myExtendedTextBox.BackColor =  myColorDialog.Color;
    }

    private void ToggleIsRequired(object sender, System.EventArgs e)
    {
      myExtendedTextBox.IsRequired = ((CheckBox)sender).Checked;
    }

    private void NotifyRequiredChange(object sender, System.EventArgs e)
    {
      MessageBox.Show(this, "Changed To: " + myExtendedTextBox.IsRequired.ToString(), 
        "IsRequired Has Changed");
    }

    /// <summary>The main entry point for the application.</summary>
    [STAThread]
    static void Main() 
    {
      Application.Run(new frmMain());
    }
	}
}
