using System;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Drawing.Design;
using System.ComponentModel;

namespace SimpleControl
{
  public class SimpleTextEditor : System.Drawing.Design.UITypeEditor
  {
    public SimpleTextEditor() {}

    public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
    {
      return UITypeEditorEditStyle.Modal;
    }

    public override object EditValue(ITypeDescriptorContext context, IServiceProvider sp, object value)
    {
      string OriginalValue = (string)value;
      SimpleTextEditorForm frm = new SimpleTextEditorForm(OriginalValue);
      IWindowsFormsEditorService EdSvc = (IWindowsFormsEditorService) sp.GetService(typeof(IWindowsFormsEditorService));
      
      if (DialogResult.OK ==  EdSvc.ShowDialog(frm))
      {
        OriginalValue = frm.EditedValue;
      }
      frm.Dispose();

      return OriginalValue;
    }
  
    protected class SimpleTextEditorForm : System.Windows.Forms.Form
    {
      private System.Windows.Forms.Label label1;
      private System.Windows.Forms.Button btnOK;
      private System.Windows.Forms.Button btnCancel;
      private System.Windows.Forms.TextBox txtTextValue;
      private System.ComponentModel.Container components = null;

      public SimpleTextEditorForm(string OriginalText)
      {
        InitializeComponent();
        this.txtTextValue.Text = OriginalText;
      }

      public string EditedValue
      {
        get {return this.txtTextValue.Text;}
        set {this.txtTextValue.Text = value;}
      }

      protected override void Dispose( bool disposing )
      {
        if( disposing )
        {
          if(components != null)
          {
            components.Dispose();
          }
        }
        base.Dispose( disposing );
      }

		#region Windows Form Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent()
      {
        this.txtTextValue = new System.Windows.Forms.TextBox();
        this.label1 = new System.Windows.Forms.Label();
        this.btnOK = new System.Windows.Forms.Button();
        this.btnCancel = new System.Windows.Forms.Button();
        this.SuspendLayout();
        // 
        // txtTextValue
        // 
        this.txtTextValue.Location = new System.Drawing.Point(59, 29);
        this.txtTextValue.Name = "txtTextValue";
        this.txtTextValue.Size = new System.Drawing.Size(124, 20);
        this.txtTextValue.TabIndex = 0;
        this.txtTextValue.Text = "";
        // 
        // label1
        // 
        this.label1.Location = new System.Drawing.Point(11, 29);
        this.label1.Name = "label1";
        this.label1.Size = new System.Drawing.Size(40, 23);
        this.label1.TabIndex = 2;
        this.label1.Text = "Text:";
        this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
        // 
        // btnOK
        // 
        this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
        this.btnOK.Location = new System.Drawing.Point(16, 80);
        this.btnOK.Name = "btnOK";
        this.btnOK.TabIndex = 1;
        this.btnOK.Text = "OK";
        // 
        // btnCancel
        // 
        this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
        this.btnCancel.Location = new System.Drawing.Point(104, 80);
        this.btnCancel.Name = "btnCancel";
        this.btnCancel.TabIndex = 2;
        this.btnCancel.Text = "Cancel";
        // 
        // SimpleTextEditorForm
        // 
        this.AcceptButton = this.btnOK;
        this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
        this.CancelButton = this.btnCancel;
        this.ClientSize = new System.Drawing.Size(194, 109);
        this.ControlBox = false;
        this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                    this.btnCancel,
                                                                    this.btnOK,
                                                                    this.label1,
                                                                    this.txtTextValue});
        this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
        this.MaximizeBox = false;
        this.MinimizeBox = false;
        this.Name = "SimpleTextEditorForm";
        this.Text = "SimpleTextEditorForm";
        this.ResumeLayout(false);

      }
		#endregion
    }
  }
}