using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;

namespace Client
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Client : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btGetColor;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private localhost.Service1 loc = new localhost.Service1();
		private System.IAsyncResult iSync;
		private System.Windows.Forms.Label lblNoOfTimes;
		private int noOfTimes = 0;
		private System.Timers.Timer timer;

		public Client()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			string color = loc.ColorPicker();
			this.BackColor = Color.FromName(color);
			timer = new System.Timers.Timer(10000);
			timer.Enabled = true;
			timer.Elapsed += new System.Timers.ElapsedEventHandler(timer_Elapsed);
		}

		protected void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			iSync = loc.BeginColorPicker(new AsyncCallback(callback), noOfTimes);
		}

		private void callback(IAsyncResult iSync)
		{
			BackColor = Color.FromName(loc.EndColorPicker(iSync));
			noOfTimes++;
			lblNoOfTimes.Text = Convert.ToString(noOfTimes);
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btGetColor = new System.Windows.Forms.Button();
			this.lblNoOfTimes = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btGetColor
			// 
			this.btGetColor.Location = new System.Drawing.Point(352, 224);
			this.btGetColor.Name = "btGetColor";
			this.btGetColor.Size = new System.Drawing.Size(96, 23);
			this.btGetColor.TabIndex = 0;
			this.btGetColor.Text = "Get Color";
			this.btGetColor.Click += new System.EventHandler(this.btGetColor_Click);
			// 
			// lblNoOfTimes
			// 
			this.lblNoOfTimes.Location = new System.Drawing.Point(8, 224);
			this.lblNoOfTimes.Name = "lblNoOfTimes";
			this.lblNoOfTimes.TabIndex = 1;
			// 
			// Client
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 254);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblNoOfTimes,
																		  this.btGetColor});
			this.MaximizeBox = false;
			this.Name = "Client";
			this.Text = "Client";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Client());
		}

		private void btGetColor_Click(object sender, System.EventArgs e)
		{
			iSync = loc.BeginColorPicker(new AsyncCallback(callback), noOfTimes);
		}
	}
}
